<template>
	<cdx-button
		v-if="!hasVoted"
		action="progressive"
		weight="primary"
		@click="open = true"
	>
		{{ $i18n( 'communitywishlist-support-focus-area' ).text() }}
	</cdx-button>
	<cdx-button
		v-else
		@click="removeVote"
	>
		<span class="cdx-button__icon cdx-demo-css-icon--check"></span>
		{{ $i18n( 'communitywishlist-supported' ).text() }}
	</cdx-button>

	<cdx-message
		v-if="showVotedMessage"
		type="success"
		allow-user-dismiss
	>
		{{ $i18n( 'communitywishlist-support-focus-area-confirmed' ).text() }}
	</cdx-message>

	<cdx-dialog
		v-model:open="open"
		:title="dialogTitle"
		:use-close-button="true"
		:primary-action="primaryAction"
		:default-action="defaultAction"
		@primary="onPrimaryAction"
		@default="open = false"
	>
		<cdx-field>
			<cdx-text-area
				:disabled="submitting"
				@input="updateComment"
			></cdx-text-area>
			<template #label>
				{{ $i18n( 'communitywishlist-optional-comment' ).text() }}
			</template>
		</cdx-field>
	</cdx-dialog>
</template>

<script>
import { defineComponent } from 'vue';
import { CdxButton, CdxDialog, CdxField, CdxTextArea, CdxMessage } from '@wikimedia/codex';
import WebUtil from './WebUtil.js';
import FocusAreaPage from '../webapp/FocusAreaPage.js';
import config from '../common/config.js';

const focusAreaPage = new FocusAreaPage();

export default defineComponent( {
	name: 'FocusArea',
	components: {
		CdxButton,
		CdxDialog,
		CdxField,
		CdxTextArea,
		CdxMessage
	},
	data() {
		return {
			open: false,
			submitting: false,
			comment: '',
			hasVoted: false,
			showVotedMessage: false
		};
	},
	computed: {
		dialogTitle() {
			return mw.msg(
				'communitywishlist-support-focus-area-dialog-title',
				WebUtil.getFocusAreaSlug()
			);
		},
		primaryAction() {
			return {
				label: mw.msg( 'communitywishlist-support' ),
				actionType: 'progressive',
				disabled: this.submitting
			};
		},
		defaultAction() {
			return {
				label: mw.msg( 'cancel' ),
				disabled: this.submitting
			};
		}
	},
	methods: {
		updateComment( event ) {
			this.comment = event.target.value;
		},
		onPrimaryAction() {
			this.submitting = true;
			focusAreaPage.loadVotes().then( ( votes ) => {
				focusAreaPage.addVote( votes, this.comment ).then( ( editResult ) => {
					this.open = false;
					if ( !editResult ) {
						return;
					}
					if ( editResult.edit.result === 'Success' ) {
						// Purge and reload the page.
						const postArgs = { action: 'purge', titles: mw.config.get( 'wgPageName' ) };
						( new mw.Api() ).post( postArgs ).then( ( purgeRes ) => {
							mw.storage.session.set( config.voteRecordedStorageName, 1 );
							location.href = mw.util.getUrl( purgeRes.purge[ 0 ].title ) + '#voting';
							// Also reload, in case they were already at #voting.
							location.reload();
						} );
					} else {
						// @todo Handle errors.
					}
				} );
			} );
		},
		removeVote() {
			// @todo Implement.
		}
	},
	beforeMount() {
		focusAreaPage.loadVotes().then( ( votes ) => {
			if ( votes && focusAreaPage.alreadyVoted( votes ) ) {
				this.hasVoted = true;
				// Also check for the session storage param for the post-voting message.
				this.showVotedMessage = mw.storage.session.get( config.voteRecordedStorageName ) !== null;
				mw.storage.session.remove( config.voteRecordedStorageName );
			}
		} );
	}
} );
</script>

<style lang="less" scoped>
@import ( reference ) '@wikimedia/codex-design-tokens/theme-wikimedia-ui.less';
@import ( reference ) '@wikimedia/codex/mixins/css-icon.less';

.cdx-button,
.cdx-message {
	margin-bottom: @spacing-100;
}

/* Hack in check icon. */
/* FIXME: Use actual Codex component when we move to the extension. */
.cdx-demo-css-icon--check {
	min-width: 20px;
	min-height: 20px;
	width: 1.25em;
	height: 1.25em;
	display: inline-block;
	/* stylelint-disable-next-line declaration-no-important */
	background-color: transparent !important;
	background-image: url( https://upload.wikimedia.org/wikipedia/commons/f/f4/Codex_icon_check.svg );
}
</style>
